import ListView, {AbsAdapter} from "./ListView";
import ListItemComp from "./ListItemComp";

const {ccclass, property} = cc._decorator;

@ccclass
export default class Helloworld extends cc.Component {

    @property(ListView)
    listView: ListView = null;

    @property(ListView)
    horListView: ListView = null;

    @property(cc.Label)
    tipLabel: cc.Label = null;

    start() {
        // 可以是其他的复杂对象数据.这里为了演示,仅使用数字数据.
        const data: number[] = [1, 2, 3, 4, 5, 6, 7, 8, 9];
        const adapter = new ListAdapter()
        adapter.setDataSet(data);
        this.listView.setAdapter(adapter);

        const adapter2 = new ListAdapter()
        adapter2.setDataSet(data);
        this.horListView.setAdapter(adapter2);

        this.scheduleOnce(() => {
            adapter.setDataSet([9, 8, 7]);
            this.listView.notifyUpdate();
            adapter2.setDataSet(["a", "b"]);
            this.horListView.notifyUpdate();
        }, 5)

        // 可选功能.
        this.listView.pullDown(() => {
            console.log("你已经上拉到最顶端了.");
            this.tipLabel.string = "你已经上拉到最顶端了.";
        }, this);
        this.listView.pullUp(() => {
            console.log("你已经下拉到最底端了.");
            this.tipLabel.string = "你已经下拉到最底端了";
        }, this);
    }
}

class ListAdapter extends AbsAdapter {
    updateView(item: cc.Node, posIndex: number) {
        let comp = item.getComponent(ListItemComp);
        if (comp) {
            comp.setData(this.getItem(posIndex));
        }
    }
}
